unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls,inifiles;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    LabeledEdit1: TLabeledEdit;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure LabeledEdit1Exit(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure uloz_programy;
    procedure nacti_programy;
    procedure obnovaplikaci(Sender: TObject);
    procedure minimalizuj(Sender: TObject);
    procedure exchange(f,t:integer);
    procedure spust_aplikaci(index:integer);
    procedure AcceptFiles( var msg : TMessage ); message WM_DROPFILES;
    procedure pridej_externi_program(filename:string);
    procedure pridej_novy_program(nazev,prog,mini:string);
  end;

var
  Form1: TForm1;
  cesta,act_nazev:string;
  vteriny,akt_index:integer;
  spoustim:boolean;

implementation

uses Unit2,shellapi, Math,ShlObj, ActiveX, ComObj;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
    pridej_novy_program('','','');
end;

procedure TForm1.pridej_novy_program(nazev,prog,mini:string);
var pauza:string;
    polozka:tlistitem;
begin
  pauza:='30';
  if not InputQuery('Pdn novho programu ...','Nzev programu',nazev) then exit;

  form2.caption:='Pdn novho programu ...';
  form2.LabeledEdit1.EditLabel.Caption:='Program a parametry';
  form2.LabeledEdit1.Text:=prog;
  Form2.CheckBox1.Checked:=mini='m';
  if form2.ShowModal<>mrOk then exit;
  prog:=Form2.LabeledEdit1.Text;
  if Form2.CheckBox1.Checked then mini:='m' else mini:='';

  if not InputQuery('Pdn novho programu ...','Doba ekn [s]',pauza) then exit;
  if strtointdef(pauza,-1)=-1 then begin
      showmessage('Poloka nebyla pidna, protoe doba ekn nebyla zadna jako slo!');
      exit;
   end;
  if ListView1.ItemIndex=-1 then polozka:=ListView1.Items.Add
  else polozka:=ListView1.Items.Insert(ListView1.ItemIndex);
  polozka.Caption:=nazev;
  polozka.SubItems.Add(prog);
  polozka.SubItems.Add(pauza);
  if (spoustim) then polozka.SubItems.Add('Ne') else polozka.SubItems.Add('');
  polozka.SubItems.Add(mini);
  uloz_programy;
end;

procedure TForm1.Button2Click(Sender: TObject);
var polozka:tlistitem;
    nazev,prog,pauza,mini:string;
begin
    if ListView1.ItemIndex=-1 then exit;
    polozka:=ListView1.Items[ListView1.ItemIndex];
    nazev:=polozka.caption;
    prog:=polozka.SubItems[0];
    pauza:=polozka.SubItems[1];
    mini:=polozka.SubItems[3];
    if not InputQuery('Editace programu ...','Nzev programu',nazev) then exit;
    //if not InputQuery('Editace programu ...','Program',prog) then exit;

    form2.caption:='Editace programu ...';
    form2.LabeledEdit1.EditLabel.Caption:='Program a parametry';
    Form2.CheckBox1.Checked:=mini='m';
    Form2.LabeledEdit1.Text:=prog;
    if form2.ShowModal<>mrOk then exit;
    prog:=Form2.LabeledEdit1.Text;
    if Form2.CheckBox1.Checked then mini:='m' else mini:='';

    if not InputQuery('Editace programu ...','Doba ekn [s]',pauza) then exit;
    if strtointdef(pauza,-1)=-1 then begin
       showmessage('Poloka nebyla zmnna, protoe doba ekn nebyla zadna jako slo!');
       exit;
    end;
    ListView1.Items[ListView1.ItemIndex].Caption:=nazev;
    ListView1.Items[ListView1.ItemIndex].SubItems[0]:=prog;
    ListView1.Items[ListView1.ItemIndex].SubItems[1]:=pauza;
    ListView1.Items[ListView1.ItemIndex].SubItems[3]:=mini;
    uloz_programy;
end;

procedure obnov_prvky;
begin
  with form1 do begin
    button2.Enabled:=ListView1.ItemIndex>-1;
    button3.Enabled:=ListView1.ItemIndex>-1;
    button4.Enabled:=ListView1.ItemIndex>0;
    button5.Enabled:=(ListView1.ItemIndex>-1) and (ListView1.ItemIndex<(ListView1.Items.Count-1));
    button6.visible:=spoustim;
    if ListView1.ItemIndex=-1 then button6.Enabled:=false
    else button6.Enabled:=ListView1.Items[ListView1.ItemIndex].SubItems[2]='Ne';
  end;
end;

procedure TForm1.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
    obnov_prvky;
end;

procedure TForm1.obnovaplikaci(Sender: TObject);
begin
    timer1.enabled:=false;
end;

procedure TForm1.minimalizuj(Sender: TObject);
begin
  if spoustim then Timer1.Enabled:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cesta:=ExtractFilePath(Application.ExeName);
  Application.OnRestore:=obnovaplikaci;
  Application.OnMinimize:=minimalizuj;

  spoustim:=false;
  if (paramcount>0) then begin
    if paramstr(1)='-run' then begin
      spoustim:=true;
    end;
  end;
  nacti_programy;
  if spoustim then begin
    form1.WindowState:=wsMinimized;
    akt_index:=-1;
    vteriny:=1;
    Timer1.Enabled:=true;
  end;

  obnov_prvky;
  DragAcceptFiles(handle,true);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    if ListView1.ItemIndex=-1 then exit;
    if (MessageBox(form1.Handle,pansichar('Smazat program '+ListView1.Selected.caption),'Upozornn',MB_YESNO)=IDYES)
      then ListView1.Items.Delete(ListView1.ItemIndex);
    uloz_programy;
end;


procedure TForm1.nacti_programy;
var st:TStringList;
    i,j:integer;
    t:tlistitem;
    f:TIniFile;
begin
    f:=tinifile.create(cesta+'programs.ini');
    LabeledEdit1.Text:=f.ReadString('Main','PrvniPauza','30');
    st:=TStringList.Create;
    f.ReadSections(st);
    if st.Count>0 then begin
      ListView1.Items.Clear;
      for i:=0 to st.count-1 do begin
        if not f.SectionExists('Program'+inttostr(i+1)) then continue;
        t:=listview1.Items.Add;
        t.Caption:=f.ReadString('Program'+inttostr(i+1),'Nazev','Program'+inttostr(i+1));
        t.SubItems.Add(f.ReadString('Program'+inttostr(i+1),'Program',''));
        t.SubItems.Add(inttostr(f.ReadInteger('Program'+inttostr(i+1),'Pauza',10)));
        if spoustim then t.SubItems.Add('Ne') else t.SubItems.Add('');
        j:=f.ReadInteger('Program'+inttostr(i+1),'Mimimalizovat',0);
        if j=1 then t.SubItems.Add('m') else t.SubItems.Add('');
      end;
    end;
    st.Free;
    f.Free;
end;

procedure TForm1.uloz_programy;
var i,j:integer;
    f:tinifile;
begin
    RenameFile(cesta+'programs.ini',cesta+'programs.bak');
    DeleteFile(cesta+'programs.ini');
    f:=tinifile.create(cesta+'programs.ini');
    f.WriteString('Main','PrvniPauza',LabeledEdit1.Text);
    for i:=0 to ListView1.Items.count-1 do begin
      f.WriteString('Program'+inttostr(i+1),'Nazev',ListView1.Items[i].Caption);
      f.WriteString('Program'+inttostr(i+1),'Program',ListView1.Items[i].SubItems[0]);
      f.WriteInteger('Program'+inttostr(i+1),'Pauza',strtoint(ListView1.Items[i].SubItems[1]));
      if ListView1.Items[i].SubItems[3]='m' then j:=1 else j:=0;
      f.WriteInteger('Program'+inttostr(i+1),'Mimimalizovat',j);
    end;
    f.UpdateFile;
    f.Free;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    uloz_programy;
end;

procedure TForm1.exchange(f,t: Integer);
var
  tempLI: TListItem;
begin
  listview1.Items.BeginUpdate;
  try
    tempLI := TListItem.Create(listview1.Items);
    tempLI.Assign(listview1.Items.Item[f]);
    listview1.Items.Item[f].Assign(listview1.Items.Item[t]);
    listview1.Items.Item[t].Assign(tempLI);
    tempLI.Free;
  finally
    listview1.Items.EndUpdate
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var i:integer;
begin
    if ListView1.ItemIndex<=0 then exit;
    i:=ListView1.ItemIndex;
    exchange(ListView1.ItemIndex,ListView1.ItemIndex-1);
    ListView1.ItemFocused:=ListView1.Items[i-1];
    ListView1.Selected:=ListView1.Items[i-1];
    ListView1.SetFocus;
    uloz_programy;
end;

procedure TForm1.Button5Click(Sender: TObject);
var i:integer;
begin
    if (ListView1.ItemIndex<0) or (ListView1.ItemIndex>=ListView1.Items.count) then exit;
    i:=ListView1.ItemIndex;
    exchange(ListView1.ItemIndex,ListView1.ItemIndex+1);
    ListView1.ItemFocused:=ListView1.Items[i+1];
    ListView1.Selected:=ListView1.Items[i+1];
    ListView1.SetFocus;
    uloz_programy;
end;

procedure TForm1.LabeledEdit1Exit(Sender: TObject);
begin
    if (strtointdef(labelededit1.Text,-1)=-1) then begin
      showmessage('Dokad to nezad jako slo, tak t nepustm dl');
      LabeledEdit1.SetFocus;
    end;
    uloz_programy;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var old_index:integer;
begin
    if akt_index>-1 then Application.Title:=inttostr(vteriny)+' - '+act_nazev;
    dec(vteriny);
    if vteriny<=0 then begin
      spust_aplikaci(akt_index);
      old_index:=akt_index;
      repeat
        akt_index:=akt_index+1;
        if akt_index=ListView1.Items.Count then begin
          Timer1.Enabled:=false;
          Application.Title:='LazyRun';
          close;
          exit;
        end;
      until ListView1.Items[akt_index].SubItems[2]='Ne';
      act_nazev:=ListView1.Items[akt_index].Caption;
      if akt_index=0 then vteriny:=strtointdef(LabeledEdit1.Text,30)
      else vteriny:=strtointdef(ListView1.Items[old_index].SubItems[1],30);
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    if spoustim then begin
      if ListView1.ItemIndex=akt_index then begin
        vteriny:=1;
        Timer1Timer(nil)
      end else spust_aplikaci(ListView1.ItemIndex);
    end;
end;

procedure TForm1.spust_aplikaci(index:integer);
var okno:integer;
begin
    if index=-1 then exit;
    if ListView1.Items[index].SubItems[2]='Ano' then exit;
    if ListView1.Items[index].SubItems[3]='m' then okno:=SW_SHOWMINNOACTIVE else okno:=SW_SHOW;
    WinExec(pansichar(ListView1.Items[index].SubItems[0]), okno);
    ListView1.Items[index].SubItems[2]:='Ano';
end;

procedure InfoZLinku(sourceName:string; var nazev,prog,mini:string);
var
   IObject : IUnknown;
   ISLink : IShellLink;
   IPFile : IPersistFile;
   dir:_WIN32_FIND_DATA;
   flagy:cardinal;
   wsourcename:PWideChar;
   //workdirectory:PAnsiChar;
   parametry,programek:PAnsiChar;
   minim:integer;
begin

   IObject := CreateComObject(CLSID_ShellLink) ;
   ISLink := IObject as IShellLink;
   IPFile := IObject as IPersistFile;
   getmem(wsourcename,1000);
   //getmem(workdirectory,1000);
   getmem(parametry,1000);
   getmem(programek,1000);
   StringToWideChar(sourceName,wsourcename,1000);
   IPFile.Load(wsourcename,0);
   flagy:=0;
   ISLink.GetPath(programek,1000,dir,flagy);
   ISLink.GetShowCmd(minim);
   //ISLink.GetWorkingDirectory(workdirectory,1000) ;
   ISLink.GetArguments(parametry,1000);
   nazev:=copy(ExtractFileName(sourceName),1,length(ExtractFileName(sourceName))-length(ExtractFileExt(sourceName)));
   prog:=programek+' '+parametry;
   if (minim=SW_SHOWMINNOACTIVE) or (minim=SW_SHOWMINIMIZED) or (minim=SW_MINIMIZE) then mini:='m' else mini:='';
end;

procedure TForm1.pridej_externi_program(filename:string);
var typ,prog,mini,nazev:string;
begin
  typ:=ExtractFileExt(filename);
  if uppercase(typ)='.LNK' then begin
    InfoZLinku(filename,nazev,prog,mini);
    pridej_novy_program(nazev,prog,mini);
  end else begin
    pridej_novy_program('',filename,'');
  end;
end;

procedure TForm1.AcceptFiles( var msg : TMessage );
const
  cnMaxFileNameLen = 255;
var
  i,
  nCount     : integer;
  acFileName : array [0..cnMaxFileNameLen] of char;
begin
  nCount := DragQueryFile( msg.WParam,
                           $FFFFFFFF,
                           acFileName,
                           cnMaxFileNameLen );

  for i := 0 to nCount-1 do
  begin
    DragQueryFile( msg.WParam, i,
                   acFileName, cnMaxFileNameLen );

    pridej_externi_program(acfilename);
  end;
  DragFinish( msg.WParam );
end;

procedure TForm1.ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
     Accept := Sender = ListView1;
end;

procedure TForm1.ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var  DropItem,CurrentItem,i: integer;
begin
    if Sender = Source then
    with TListView(Sender) do
    begin
      if GetItemAt(X, Y)=nil then exit;
      DropItem    := GetItemAt(X, Y).index;
      CurrentItem := Selected.index;
      if dropitem=currentitem then exit;
      if DropItem>CurrentItem then begin
        for i:=CurrentItem to DropItem-1 do begin
          exchange(i,i+1);
        end;
      end else begin
        for i:=CurrentItem downto DropItem+1 do begin
          exchange(i,i-1);
        end;
      end

    end;
end;

end.
